All of lore.kernel.org
 help / color / mirror / Atom feed
From: Max Reitz <mreitz@redhat.com>
To: qemu-block@nongnu.org
Cc: Kevin Wolf <kwolf@redhat.com>, Fam Zheng <famz@redhat.com>,
	qemu-devel@nongnu.org, Max Reitz <mreitz@redhat.com>,
	Paolo Bonzini <pbonzini@redhat.com>,
	Alberto Garcia <berto@igalia.com>, John Snow <jsnow@redhat.com>
Subject: [Qemu-devel] [PATCH v8 02/16] iotests: Add test for eject under NBD server
Date: Wed, 27 Jan 2016 18:59:46 +0100	[thread overview]
Message-ID: <1453917600-2663-3-git-send-email-mreitz@redhat.com> (raw)
In-Reply-To: <1453917600-2663-1-git-send-email-mreitz@redhat.com>

This patch adds a test for ejecting the BlockBackend an NBD server is
connected to (the NBD server is supposed to stop).

Signed-off-by: Max Reitz <mreitz@redhat.com>
---
 tests/qemu-iotests/140     | 92 ++++++++++++++++++++++++++++++++++++++++++++++
 tests/qemu-iotests/140.out | 16 ++++++++
 tests/qemu-iotests/group   |  1 +
 3 files changed, 109 insertions(+)
 create mode 100755 tests/qemu-iotests/140
 create mode 100644 tests/qemu-iotests/140.out

diff --git a/tests/qemu-iotests/140 b/tests/qemu-iotests/140
new file mode 100755
index 0000000..3434997
--- /dev/null
+++ b/tests/qemu-iotests/140
@@ -0,0 +1,92 @@
+#!/bin/bash
+#
+# Test case for ejecting a BB with an NBD server attached to it
+#
+# Copyright (C) 2015 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=mreitz@redhat.com
+
+seq="$(basename $0)"
+echo "QA output created by $seq"
+
+here="$PWD"
+tmp=/tmp/$$
+status=1	# failure is the default!
+
+_cleanup()
+{
+    _cleanup_test_img
+    rm -f "$TEST_DIR/nbd"
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+. ./common.qemu
+
+_supported_fmt generic
+_supported_proto file
+_supported_os Linux
+
+_make_test_img 64k
+
+$QEMU_IO -c 'write -P 42 0 64k' "$TEST_IMG" | _filter_qemu_io
+
+keep_stderr=y \
+_launch_qemu -drive if=ide,media=cdrom,id=drv,file="$TEST_IMG",format=$IMGFMT \
+    2> >(_filter_nbd)
+
+_send_qemu_cmd $QEMU_HANDLE \
+    "{ 'execute': 'qmp_capabilities' }" \
+    'return'
+
+_send_qemu_cmd $QEMU_HANDLE \
+    "{ 'execute': 'nbd-server-start',
+       'arguments': { 'addr': { 'type': 'unix',
+                                'data': { 'path': '$TEST_DIR/nbd' }}}}" \
+    'return'
+
+_send_qemu_cmd $QEMU_HANDLE \
+    "{ 'execute': 'nbd-server-add',
+       'arguments': { 'device': 'drv' }}" \
+    'return'
+
+$QEMU_IO_PROG -f raw -c 'read -P 42 0 64k' \
+    "nbd+unix:///drv?socket=$TEST_DIR/nbd" 2>&1 \
+    | _filter_qemu_io | _filter_nbd
+
+_send_qemu_cmd $QEMU_HANDLE \
+    "{ 'execute': 'eject',
+       'arguments': { 'device': 'drv' }}" \
+    'return'
+
+$QEMU_IO_PROG -f raw -c close \
+    "nbd+unix:///drv?socket=$TEST_DIR/nbd" 2>&1 \
+    | _filter_qemu_io | _filter_nbd
+
+_send_qemu_cmd $QEMU_HANDLE \
+    "{ 'execute': 'quit' }" \
+    'return'
+
+wait=1 _cleanup_qemu
+
+# success, all done
+echo '*** done'
+rm -f $seq.full
+status=0
diff --git a/tests/qemu-iotests/140.out b/tests/qemu-iotests/140.out
new file mode 100644
index 0000000..fdedeb3
--- /dev/null
+++ b/tests/qemu-iotests/140.out
@@ -0,0 +1,16 @@
+QA output created by 140
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=65536
+wrote 65536/65536 bytes at offset 0
+64 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+{"return": {}}
+{"return": {}}
+{"return": {}}
+read 65536/65536 bytes at offset 0
+64 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+{"timestamp": {"seconds":  TIMESTAMP, "microseconds":  TIMESTAMP}, "event": "DEVICE_TRAY_MOVED", "data": {"device": "drv", "tray-open": true}}
+{"return": {}}
+can't open device nbd+unix:///drv?socket=TEST_DIR/nbd: Failed to read export length
+no file open, try 'help open'
+{"return": {}}
+{"timestamp": {"seconds":  TIMESTAMP, "microseconds":  TIMESTAMP}, "event": "SHUTDOWN"}
+*** done
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
index ac6a959..ff1ff0d 100644
--- a/tests/qemu-iotests/group
+++ b/tests/qemu-iotests/group
@@ -141,5 +141,6 @@
 137 rw auto
 138 rw auto quick
 139 rw auto quick
+140 rw auto quick
 142 auto
 143 auto quick
-- 
2.7.0

  parent reply	other threads:[~2016-01-27 18:00 UTC|newest]

Thread overview: 38+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2016-01-27 17:59 [Qemu-devel] [PATCH v8 00/16] block: Rework bdrv_close_all() Max Reitz
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 01/16] block: Release dirty bitmaps in bdrv_close() Max Reitz
2016-01-28  3:01   ` Fam Zheng
2016-01-29 13:27     ` Max Reitz
2016-01-27 17:59 ` Max Reitz [this message]
2016-01-27 20:56   ` [Qemu-devel] [PATCH v8 02/16] iotests: Add test for eject under NBD server Eric Blake
2016-01-29 13:07     ` Max Reitz
2016-01-28  3:05   ` Fam Zheng
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 03/16] block: Add BB-BDS remove/insert notifiers Max Reitz
2016-01-28  3:06   ` Fam Zheng
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 04/16] virtio-blk: Functions for op blocker management Max Reitz
2016-01-28  3:09   ` Fam Zheng
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 05/16] virtio-scsi: Catch BDS-BB removal/insertion Max Reitz
2016-01-28  3:14   ` Fam Zheng
2016-01-29 12:41   ` Kevin Wolf
2016-01-29 14:13     ` Max Reitz
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 06/16] nbd: Switch from close to eject notifier Max Reitz
2016-01-28  3:26   ` Fam Zheng
2016-01-29 13:39     ` Max Reitz
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 07/16] block: Remove BDS close notifier Max Reitz
2016-01-28  3:27   ` Fam Zheng
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 08/16] block: Use blk_remove_bs() in blk_delete() Max Reitz
2016-01-28  3:28   ` Fam Zheng
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 09/16] blockdev: Use blk_remove_bs() in do_drive_del() Max Reitz
2016-01-28  3:29   ` Fam Zheng
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 10/16] block: Make bdrv_close() static Max Reitz
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 11/16] block: Add list of all BlockDriverStates Max Reitz
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 12/16] blockdev: Keep track of monitor-owned BDS Max Reitz
2016-01-28  3:33   ` Fam Zheng
2016-01-29 13:44     ` Max Reitz
2016-01-29 13:49       ` Kevin Wolf
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 13/16] block: Add blk_remove_all_bs() Max Reitz
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 14/16] block: Rewrite bdrv_close_all() Max Reitz
2016-01-28  4:17   ` Fam Zheng
2016-01-29 13:54     ` Max Reitz
2016-01-27 17:59 ` [Qemu-devel] [PATCH v8 15/16] iotests: Add test for multiple BB on BDS tree Max Reitz
2016-01-27 18:00 ` [Qemu-devel] [PATCH v8 16/16] iotests: Add test for block jobs and BDS ejection Max Reitz
2016-01-29 13:45 ` [Qemu-devel] [PATCH v8 00/16] block: Rework bdrv_close_all() Kevin Wolf

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1453917600-2663-3-git-send-email-mreitz@redhat.com \
    --to=mreitz@redhat.com \
    --cc=berto@igalia.com \
    --cc=famz@redhat.com \
    --cc=jsnow@redhat.com \
    --cc=kwolf@redhat.com \
    --cc=pbonzini@redhat.com \
    --cc=qemu-block@nongnu.org \
    --cc=qemu-devel@nongnu.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.